//
//  ViewController.m
//  分栏控制
//
//  Created by apple on 16/1/21.
//  Copyright (c) 2016年 apple. All rights reserved.
//

#import "ViewController.h"
#define WIDTH self.view.frame.size.width
#define HEIGHT self.view.frame.size.height
#define COLOR arc4random() % (255 + 1)
@interface ViewController ()<UIScrollViewDelegate>

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    
    [self creatBtn];
    
    UIButton *firstBtn = (UIButton *)[self.view viewWithTag:1];
    
    firstBtn.selected = YES;
    
    [self creatLine];
    
    [self creatScrollView];
    
}

- (void)creatBtn{

    for (int i = 0; i < 4; i++) {
        
        UIButton *btn = [[UIButton alloc]initWithFrame:CGRectMake(WIDTH / 4 * i, 22, WIDTH / 4, 44)];
        
        btn.backgroundColor = [UIColor colorWithRed:COLOR/255.0 green:COLOR/255.0 blue:COLOR/255.0 alpha:1];
        
        [btn setTitle:[NSString stringWithFormat:@"第%d栏", i + 1] forState:UIControlStateNormal];
        
        [btn setTitleColor:[UIColor redColor] forState:UIControlStateSelected];
        
        btn.tag = i + 1;
        
        [btn addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
        
        [self.view addSubview:btn];
        
    }
    
}

- (void)btnClick:(UIButton *)btn{
    
    for (int i = 0; i < 4; i++) {
        
        UIButton *allBtn = (UIButton *)[self.view viewWithTag:i + 1];
        
        allBtn.selected = NO;
        
    }

    btn.selected = YES;
    
    UILabel *label = (UILabel *)[self.view viewWithTag:100];
    
    CGRect rect = label.frame;
    
    rect.origin.x = WIDTH / 4 * (btn.tag - 1);
    
    label.frame = rect;
    
    UIScrollView *scrollView = (UIScrollView *)[self.view viewWithTag:101];
    
    scrollView.contentOffset = CGPointMake((btn.tag - 1) * WIDTH, 0);

}

- (void)creatLine{

    UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 65, WIDTH / 4, 5)];
    
    label.tag = 100;
    
    label.backgroundColor = [UIColor redColor];
    
    [self.view addSubview:label];

}

- (void)creatScrollView{

    UIScrollView *scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 70, WIDTH, HEIGHT - 70)];
    
    scrollView.tag = 101;
    
    scrollView.delegate = self;
    
    scrollView.contentSize = CGSizeMake(WIDTH * 4, HEIGHT - 70);
    
    scrollView.pagingEnabled = YES;
    
    scrollView.bounces = NO;
    
    NSArray *array = @[@"First", @"Second", @"Third", @"Fourth"];
    
    for (int i = 0; i < 4; i++) {
        
        Class class = NSClassFromString([NSString stringWithFormat:@"%@ViewController", array[i]]);
        
        UIViewController *vc = [[class alloc]init];
        
        vc.view.frame = CGRectMake(WIDTH * i, 0, WIDTH, HEIGHT - 70);
        
        [scrollView addSubview:vc.view];
        
    }
    
    [self.view addSubview:scrollView];
    
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView{

    UIScrollView *scroll = (UIScrollView *)[self.view viewWithTag:101];
    
    int currentPage = scroll.contentOffset.x / WIDTH;
    
    UIButton *button = (UIButton *)[self.view viewWithTag:currentPage + 1];
    
    [self btnClick:button];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
